clear all;

%===
% integration of the lorenz system
% using RK4
%===

Dt=0.01; 
Nsteps =2000;
x=[0.2 0.2 0.1]';

plot3(x(1),x(2),x(3),'o');
hold on;
view(-45,30);

t = 0.0;
for k=1:Nsteps
 fk    = lor_fnc(t, x);
 xtmp1 = x+0.5*Dt*fk;
 ftmp1 = lor_fnc(t+0.5*Dt, xtmp1);
 xtmp2 = x+0.5*Dt*ftmp1;
 ftmp2 = lor_fnc(t+0.5*Dt, xtmp2);
 xtmp3 = x+Dt*ftmp2;
 ftmp3 = lor_fnc(t+Dt, xtmp3);
 ffin  = (fk+2*ftmp1+2*ftmp2+ftmp3)/6.0;
 xnew = x + Dt*ffin;
 plot3([x(1) xnew(1)] ,[x(2) xnew(2)] ,[x(3) xnew(3)]);
 x = xnew;
 t = t+Dt;
end 
